"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class TypeChecker {
    constructor(typescript, virtualServiceHost, getTypeChecker) {
        this.typescript = typescript;
        this.virtualServiceHost = virtualServiceHost;
        this.getTypeChecker = getTypeChecker;
        this.registry = this.typescript.createDocumentRegistry(true);
        this.service = this.typescript.createLanguageService(virtualServiceHost, this.registry, false);
    }
    getType(node) {
        const checker = this.getTypeChecker();
        const type = checker.getTypeAtLocation(node);
        return checker.typeToString(type, undefined, this.typescript.TypeFormatFlags.NoTruncation);
    }
    check(content) {
        const fileName = `_${Math.floor(Math.random() * 100000)}.ts`;
        return this.virtualServiceHost.withFile(fileName, content, () => this.service.getSemanticDiagnostics(fileName));
    }
}
exports.TypeChecker = TypeChecker;
//# sourceMappingURL=type-checker.js.map